﻿using System.ComponentModel;
using System.Windows.Forms;

namespace AppLauncher.Windows.Forms
{
    public partial class TileGroupLabel : AUserControl
    {
        protected bool isChecked = true;

        public TileGroupLabel() : base()
        {
            InitializeComponent();
        }

        [Category("Appearance"), Browsable(true)]
        public string TitleText { get => label1.Text; set => label1.Text = value; }

        [Category("Appearance"), Browsable(true)]
        public bool Checked
        {
            get => isChecked;
            set
            {
                isChecked = value;

                pictureBox1.BackgroundImage = (value) ? Properties.Resources.toggle_right_ea_16 : Properties.Resources.toggle_left_ea_16;

                if (this.TileGroupPanel != null)
                {
                    this.TileGroupPanel.InvalidateContainer();
                }
            }
        }

        [Browsable(false), EditorBrowsable(EditorBrowsableState.Never)]
        public TileContainer TileGroupPanel { get; set; } = null;

        protected void panel_MouseClick(object sender, MouseEventArgs e)
        {
            if (e.Button != MouseButtons.Left)
            {
                return;
            }

            this.Checked = !this.Checked;
        }

    }
}